package com.ventas.pedidoscomercial;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.ventas.database.ArticuloDBAdapter;
import com.ventas.database.ClienteDBAdapter;
import com.ventas.database.DBAdapter;
import com.ventas.database.FclespDBAdapter;
import com.ventas.database.FcliDBAdapter;
import com.ventas.database.FcloferDBAdapter;
import com.ventas.database.FcomercDBAdapter;
import com.ventas.database.FcomespDBAdapter;
import com.ventas.database.FpreminimoDBAdapter;

import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.TextView;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;

public class ArticuloPrecios extends Activity {
	public  static int REQUEST_CLIENTE  = 1;
	public  static int REQUEST_ARTICULO = 2;
	
	private DBAdapter mDbHelper; 
	private String    mCodiclie;	//Cdigo de cliente asignado al iniciar la actividad.
	private String    mCodiarti;	//Cdigo de artculo asignado al iniciar la actividad.
	private String    mVigencia;	//Fecha de vigencia del precio especial asignado al iniciar la actividad.
	
	private EditText  mPrecios_codiclie;
	private TextView  mPrecios_descclie;
	private EditText  mPrecios_codiarti;
	private TextView  mPrecios_descarti;
	private TextView  mPrecios_tarifa;
	private TextView  mPrecios_udtarifa;
	private TextView  mPrecios_minimo;
	private TextView  mPrecios_udminimo;
	private TextView  mPrecios_vcliesp;
	private TextView  mPrecios_cliesp;
	private TextView  mPrecios_udcliesp;
	private TextView  mPrecios_ccliesp;
	private TextView  mPrecios_udcomiespe;
	private TextView  mPrecios_vcomercio;
	private TextView  mPrecios_comercio;
	private TextView  mPrecios_udcomercio;
	private TextView  mPrecios_nomcomercio;
	private TextView  mPrecios_desdeoferta;
	private TextView  mPrecios_hastaoferta;
	private TextView  mPrecios_oferta;
	private TextView  mPrecios_udoferta;
	private TextView  mPrecios_coferta;
	private TextView  mPrecios_udcoferta;
	private TextView  mPrecios_doferta1;
	private TextView  mPrecios_doferta2;
	private TextView  mPrecios_doferta3;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_articulo_precios);
        
        try{
	        mDbHelper = new DBAdapter(this);
	        mDbHelper.open();
        }
        catch (Exception e){
        	return;
        }

        // Get the message from the intent
		mVigencia = (savedInstanceState == null) ? null :
        			savedInstanceState.getString("VIGENCIA");
		if (mVigencia == null) {
			Bundle extras = getIntent().getExtras();
			mVigencia = extras != null ? extras.getString("VIGENCIA")
									: null;
			if (mVigencia == null) 
				mVigencia  = (new SimpleDateFormat("yyyy/MM/dd")).format(new Date());
		}

        // Get the message from the intent
        mCodiclie = (savedInstanceState == null) ? null :
        			savedInstanceState.getString(ClienteDBAdapter.DATABASE_TABLE);
		if (mCodiclie == null) {
			Bundle extras = getIntent().getExtras();
			mCodiclie = extras != null ? extras.getString(ClienteDBAdapter.DATABASE_TABLE)
									: null;
		}

        // Get the message from the intent
		mCodiarti = (savedInstanceState == null) ? null :
        		savedInstanceState.getString(ArticuloDBAdapter.DATABASE_TABLE);
		if (mCodiarti == null) {
			Bundle extras = getIntent().getExtras();
			mCodiarti = extras != null ? extras.getString(ArticuloDBAdapter.DATABASE_TABLE)
									: null;
		}

		mPrecios_codiclie    = (EditText) findViewById(R.id.precios_codiclie);
		mPrecios_descclie    = (TextView) findViewById(R.id.precios_descclie);
		mPrecios_codiarti    = (EditText) findViewById(R.id.precios_codiarti);
		mPrecios_descarti    = (TextView) findViewById(R.id.precios_descarti);
		mPrecios_tarifa      = (TextView) findViewById(R.id.precios_tarifa);
		mPrecios_udtarifa    = (TextView) findViewById(R.id.precios_udtarifa);
		mPrecios_minimo      = (TextView) findViewById(R.id.precios_minimo);
		mPrecios_udminimo    = (TextView) findViewById(R.id.precios_udminimo);
		mPrecios_vcliesp     = (TextView) findViewById(R.id.precios_vcliesp);
		mPrecios_cliesp      = (TextView) findViewById(R.id.precios_cliesp);
		mPrecios_udcliesp    = (TextView) findViewById(R.id.precios_udcliesp);
		mPrecios_ccliesp     = (TextView) findViewById(R.id.precios_ccliesp);
		mPrecios_udcomiespe  = (TextView) findViewById(R.id.precios_udcomiespe);
		mPrecios_vcomercio   = (TextView) findViewById(R.id.precios_vcomercio);
		mPrecios_comercio    = (TextView) findViewById(R.id.precios_comercio);
		mPrecios_udcomercio  = (TextView) findViewById(R.id.precios_udcomercio);
		mPrecios_nomcomercio = (TextView) findViewById(R.id.precios_nomcomercio);
		mPrecios_desdeoferta = (TextView) findViewById(R.id.precios_desdeoferta);
		mPrecios_hastaoferta = (TextView) findViewById(R.id.precios_hastaoferta);
		mPrecios_oferta      = (TextView) findViewById(R.id.precios_oferta);
		mPrecios_udoferta    = (TextView) findViewById(R.id.precios_udoferta);
		mPrecios_coferta     = (TextView) findViewById(R.id.precios_coferta);
		mPrecios_udcoferta   = (TextView) findViewById(R.id.precios_udcoferta);
		mPrecios_doferta1    = (TextView) findViewById(R.id.precios_doferta1);
		mPrecios_doferta2    = (TextView) findViewById(R.id.precios_doferta2);
		mPrecios_doferta3    = (TextView) findViewById(R.id.precios_doferta3);

		
        //Eventos sobre el campo de texto para detectar la introduccin de texto y filtrar por cliente.
		mPrecios_codiclie.addTextChangedListener(new TextWatcher() { 
            public void onTextChanged(CharSequence s, int start, int before, int count){ 
            	mCodiclie = mPrecios_codiclie.getText().toString();
            	fillData();
            } 
        
            public void beforeTextChanged(CharSequence s, int start, int count, int after){ 
            } 
        
            public void afterTextChanged(Editable s){
            } 
        }); 
		
        //Eventos sobre el campo de texto para detectar la introduccin de texto y filtrar por cliente.
		mPrecios_codiarti.addTextChangedListener(new TextWatcher() { 
            public void onTextChanged(CharSequence s, int start, int before, int count){ 
            	mCodiarti = mPrecios_codiarti.getText().toString();
            	fillData();
            } 
        
            public void beforeTextChanged(CharSequence s, int start, int count, int after){ 
            } 
        
            public void afterTextChanged(Editable s){
            } 
        }); 

		//Si abrimos con el parmetro cliente, lo metemos en su editText para que el evento
		//mPrecios_codiclie.addTextChangedListener rellene los campos necesarios con fillData().
    	if (mCodiclie != null)
            mPrecios_codiclie.setText(mCodiclie);
            
		//Si abrimos con el parmetro articulo, lo metemos en su editText para que el evento
		//mPrecios_codiarti.addTextChangedListener rellene los campos necesarios con fillData().
		if (mCodiarti != null)
            mPrecios_codiarti.setText(mCodiarti);

		getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    public void onDestroy() {
    	super.onDestroy();

    	mDbHelper.close();
    }

    public void msboxFinish(String str) 
    { 
        AlertDialog.Builder dlgAlert  = new AlertDialog.Builder(this);                       
        dlgAlert.setMessage(str);  
        dlgAlert.setPositiveButton("Aceptar",new DialogInterface.OnClickListener() { 
            public void onClick(DialogInterface dialog, int whichButton) {
                finish();  
            } 
       }); 

        dlgAlert.setCancelable(true); 
        dlgAlert.create().show(); 
    } 


    private void fillData() {
    	Cursor cliente   = null;
    	Cursor articulo  = null;
    	
    	DecimalFormat nf = new DecimalFormat("###,##0.00");
    	double auxValue;
    	String codiunid  = "";
    	
    	try{
    		mPrecios_descclie.setText("");
    		mPrecios_descarti.setText("");

    		mPrecios_tarifa.setText("");
    		mPrecios_udtarifa.setText("");
    		mPrecios_minimo.setText("");
    		mPrecios_udminimo.setText("");
    		
    		mPrecios_vcliesp.setText("");
    		mPrecios_cliesp.setText("");
    		mPrecios_udcliesp.setText("");
    		mPrecios_ccliesp.setText("");
    		mPrecios_udcomiespe.setText("");

    		mPrecios_vcomercio.setText("");
    		mPrecios_comercio.setText("");
    		mPrecios_udcomercio.setText("");
    		mPrecios_nomcomercio.setText("");
    		
    		mPrecios_desdeoferta.setText("");
    		mPrecios_hastaoferta.setText("");
    		mPrecios_oferta.setText("");
    		mPrecios_udoferta.setText("");
    		mPrecios_coferta.setText("");
    		mPrecios_udcoferta.setText("");
    		mPrecios_doferta1.setText("");
    		mPrecios_doferta2.setText("");
    		mPrecios_doferta3.setText("");

    		//Controlamos la excepcin en caso que mCodiclie no contenga un nmero vlido.
    		try{
	        	if (mCodiclie != null)
		            cliente  = mDbHelper.getCliente(Integer.valueOf(mCodiclie).intValue());
	        }
        	catch (Exception e1){
        		mCodiclie = null;
        	}
    		
        	if ((mCodiclie != null) && (cliente.getCount() > 0))
	            	mPrecios_descclie.setText(cliente.getString(cliente.getColumnIndexOrThrow(ClienteDBAdapter.DESCRIPCION)));
	            
    		//Si no hay artculo, no hay precios.
    		if (mCodiarti != null){
	            articulo  = mDbHelper.getArticulo(mCodiarti);
	            
	            //Precio tarifa y precio mnimo.
	            if (articulo.getCount() > 0){
	            	mPrecios_descarti.setText(articulo.getString(articulo.getColumnIndexOrThrow(ArticuloDBAdapter.DESCARTI)));
	            	codiunid = "  " + articulo.getString(articulo.getColumnIndexOrThrow(ArticuloDBAdapter.CODIUNID));
	            	
	            	//Precio tarifa
	            	auxValue = articulo.getDouble(articulo.getColumnIndexOrThrow(ArticuloDBAdapter.PRECTARI));
	            	if (auxValue != 0){
		        		mPrecios_tarifa.setText(nf.format(auxValue));
		            	mPrecios_udtarifa.setText(codiunid);
	            	}

	            	this.pintaPrecioMinimo(codiunid);
		            
		            //Si tenemos el cdigo de cliente, podemos pintar el precio especial para cliente, el precio comercio y
		            //la oferta en su caso.
		        	if (mCodiclie != null){
		        		this.pintaPrecioEspecial(codiunid);
		        		this.pintaPrecioComercio(codiunid);
		        		this.pintaPrecioOferta(codiunid);
		        	}
	            }
    		}
    		
        	if (mCodiclie != null)
        		cliente.close();
        	
    		if (mCodiarti != null)
    			articulo.close();
    	}
    	catch (Exception e){
    		msboxFinish("Error en el acceso a los datos.");
    	}
    	
    }
    
    
    private void pintaPrecioMinimo(String codiunid) {
    	DecimalFormat nf = new DecimalFormat("###,##0.00");
    	Cursor preminimo = null;
    	double auxValue;

    	preminimo = mDbHelper.getFpreminimo(mVigencia, mCodiarti);

    	if (preminimo.getCount() > 0){
        	auxValue = preminimo.getDouble(preminimo.getColumnIndexOrThrow(FpreminimoDBAdapter.MINIMO));
        	if (auxValue != 0){
            	mPrecios_minimo.setText(nf.format(auxValue));
            	mPrecios_udminimo.setText(codiunid);
        	}
        	
        }
    	preminimo.close();
    }

    private void pintaPrecioEspecial(String codiunid) throws Exception{
    	DecimalFormat nf = new DecimalFormat("###,##0.00");
    	Cursor cliesp    = null;
    	double auxValue;

    	cliesp  = mDbHelper.getFclesp(mVigencia, Integer.valueOf(mCodiclie).intValue(), mCodiarti);
        if (cliesp.getCount() > 0){
        	//Fecha de vigencia
    		String strDate = cliesp.getString(cliesp.getColumnIndexOrThrow(FclespDBAdapter.DESDEFECHA));
        	Date dtDate = (new SimpleDateFormat("yyyy/MM/dd")).parse(strDate);	
        	strDate = (new SimpleDateFormat("dd/MM/yyy")).format(dtDate);
        	mPrecios_vcliesp.setText(strDate);

        	//Precio especial
        	auxValue = cliesp.getDouble(cliesp.getColumnIndexOrThrow(FclespDBAdapter.PRECIO));
        	if (auxValue != 0){
        		mPrecios_cliesp.setText(nf.format(auxValue));
        		mPrecios_udcliesp.setText(codiunid);
        	}

        	//Comisin del comercial en el precio especial
        	auxValue = cliesp.getDouble(cliesp.getColumnIndexOrThrow(FclespDBAdapter.COMISION));
        	if (auxValue != 0){
        		mPrecios_ccliesp.setText(nf.format(auxValue));
        		mPrecios_udcomiespe.setText(codiunid);
        	}
        }	

        if (cliesp != null)
        	cliesp.close();
    }
    
    private void pintaPrecioComercio(String codiunid) throws Exception{
    	DecimalFormat nf      = new DecimalFormat("###,##0.00");
    	Cursor fcli           = null;
    	Cursor preciocomercio = null;
    	Cursor comercio       = null;
    	String auxStr         = "";
    	double auxValue;

    	fcli = mDbHelper.getFcli(Integer.valueOf(mCodiclie).intValue());
    	if (fcli.getCount() > 0){
	    	preciocomercio  = mDbHelper.getFcomesp(mVigencia, fcli.getString(fcli.getColumnIndexOrThrow(FcliDBAdapter.CODICOME)), mCodiarti);
	        if (preciocomercio.getCount() > 0){
	        	//Fecha de vigencia
	    		String strDate = preciocomercio.getString(preciocomercio.getColumnIndexOrThrow(FcomespDBAdapter.DESDEFECHA));
	        	Date dtDate = (new SimpleDateFormat("yyyy/MM/dd")).parse(strDate);	
	        	strDate = (new SimpleDateFormat("dd/MM/yyy")).format(dtDate);
	        	mPrecios_vcomercio.setText(strDate);
	
	        	//Precio especial
	        	auxValue = preciocomercio.getDouble(preciocomercio.getColumnIndexOrThrow(FcomespDBAdapter.PRECIO));
	        	if (auxValue != 0){
	        		mPrecios_comercio.setText(nf.format(auxValue));
	        		mPrecios_udcomercio.setText(codiunid);
	        	}
	
	        	auxStr = preciocomercio.getString(preciocomercio.getColumnIndexOrThrow(FcomespDBAdapter.CODICOME));
	        	comercio  = mDbHelper.getFcomerc(auxStr);
	
	        	//Nombre del comercio
	            if (comercio.getCount() > 0){
	            	mPrecios_nomcomercio.setText(comercio.getString(comercio.getColumnIndexOrThrow(FcomercDBAdapter.DESCCOME)));
	        	}
	        }	
        
    	}
    	
    	if (fcli != null)
    		fcli.close();
    	if (preciocomercio != null)
        	preciocomercio.close();
        if (comercio != null)
        	comercio.close();
    }
    
    
    private void pintaPrecioOferta(String codiunid) throws Exception{
    	DecimalFormat nf = new DecimalFormat("###,##0.00");
    	Cursor oferta    = null;
    	double auxValue;
		String cantdesc  = "";				
		String cantregal = "";				
		String codiarre  = "";

    	oferta  = mDbHelper.getFclesp(mVigencia, Integer.valueOf(mCodiclie).intValue(), mCodiarti);
        if (oferta.getCount() > 0){
        	//Fecha desde
    		String strDate = oferta.getString(oferta.getColumnIndexOrThrow(FcloferDBAdapter.FECHDESD));
        	Date dtDate = (new SimpleDateFormat("yyyy/MM/dd")).parse(strDate);	
        	strDate = (new SimpleDateFormat("dd/MM/yyy")).format(dtDate);
        	mPrecios_desdeoferta.setText(strDate);

        	//Fecha hasta
    		strDate = oferta.getString(oferta.getColumnIndexOrThrow(FcloferDBAdapter.FECHHAST));
        	dtDate = (new SimpleDateFormat("yyyy/MM/dd")).parse(strDate);	
        	strDate = (new SimpleDateFormat("dd/MM/yyy")).format(dtDate);
        	mPrecios_hastaoferta.setText(strDate);

        	//Precio oferta
        	auxValue = oferta.getDouble(oferta.getColumnIndexOrThrow(FcloferDBAdapter.PRECCOFE));
        	if (auxValue != 0){
        		mPrecios_oferta.setText(nf.format(auxValue));
        		mPrecios_udoferta.setText(codiunid);
        	}

        	//Comisin del comercial en el precio especial
        	auxValue = oferta.getDouble(oferta.getColumnIndexOrThrow(FcloferDBAdapter.COMISION));
        	if (auxValue != 0){
        		mPrecios_coferta.setText(nf.format(auxValue));
        		mPrecios_udcoferta.setText(codiunid);
        	}
        	

        	cantdesc  = oferta.getString(oferta.getColumnIndexOrThrow(FcloferDBAdapter.CANTDESC));				
        	cantregal = oferta.getString(oferta.getColumnIndexOrThrow(FcloferDBAdapter.CANTREGAL));				
        	codiarre  = oferta.getString(oferta.getColumnIndexOrThrow(FcloferDBAdapter.CODIARRE));

			if ((!cantdesc.equalsIgnoreCase("")) && (!cantregal.equalsIgnoreCase("")) && (!codiarre.equalsIgnoreCase(""))){
	    		mPrecios_doferta1.setText("Por un pedido de al menos " + cantdesc + " UND");
	    		mPrecios_doferta2.setText("existe una promocin de " + cantregal + " UND");
	    		mPrecios_doferta3.setText("de " + codiarre);
			}
        	
        }	

        if (oferta != null)
        	oferta.close();
    }
    
    
    /** Called when the user clicks the buscarCliente button */
    public void buscarCliente(View view) {
        Intent intent = new Intent(this, ClienteListActivity.class);
    	intent.putExtra("PERMITE_NAVEGACION", "NO");
    	startActivityForResult(intent, REQUEST_CLIENTE);
    }

    /** Called when the user clicks the buscarArticulo button */
    public void buscarArticulo(View view) {
        Intent intent = new Intent(this, ArticuloListActivity.class);
    	intent.putExtra("PERMITE_NAVEGACION", "NO");
    	startActivityForResult(intent, REQUEST_ARTICULO);
    }


    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    	try{
	        if (resultCode == RESULT_OK) {
	    	    if (requestCode == REQUEST_ARTICULO){
		            if (data.hasExtra("ARTICULO_KEY")) {
		        		//Lo devuelto en la bsqueda de artculo, lo metemos en su editText para que el evento
		        		//mPrecios_codiclie.addTextChangedListener rellene los campos necesarios con fillData().
		            	mPrecios_codiarti.setText(data.getExtras().getString("ARTICULO_KEY"));
		            }
		        } else if (requestCode == REQUEST_CLIENTE){
		            if (data.hasExtra("CLIENTE_KEY")) {
		        		//Lo devuelto en la bsqueda de cliente, lo metemos en su editText para que el evento
		        		//mPrecios_codiarti.addTextChangedListener rellene los campos necesarios con fillData().
		            	mPrecios_codiclie.setText(data.getExtras().getString("CLIENTE_KEY"));
		            }
		        }
	        }
    	}
    	catch (Exception e){
    		msboxFinish("Error en la bsqueda.");
    	}
    } 

}
