package com.ventas.pedidoscomercial;

import com.ventas.database.ClienteDBAdapter;
import com.ventas.database.DBAdapter;
import com.ventas.database.FcliDBAdapter;
import com.ventas.database.FinciDBAdapter;
import com.ventas.database.FmencliDBAdapter;

import android.os.Bundle;
import android.widget.TextView;
import android.app.Activity;
import android.database.Cursor;

public class ClienteView extends Activity {

	private Long      mCodiclie;
	private DBAdapter mDbHelper;
	private TextView  mCodiclieText;
	private TextView  mGrabaText;
	private TextView  mDescripcionText;
	private TextView  mTitularText;
	private TextView  mCodigoPostalText;
	private TextView  mPoblacionText;
	private TextView  mTelefono1Text;
	private TextView  mTelefono2Text;
	private TextView  mObservacion1Text;
	private TextView  mObservacion2Text;
	private TextView  mMensajeText;
	private TextView  mIncidenciaText;
	private TextView  mIncidenciaTmpText;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cliente_view);

        try{
	        mDbHelper = new DBAdapter(this);
	        mDbHelper.open();
        }
        catch (Exception e){
        	return;
        }

        // Get the message from the intent
        mCodiclie = (savedInstanceState == null) ? null :
            (Long) savedInstanceState.getSerializable(ClienteDBAdapter.CODICLIE);
		if (mCodiclie == null) {
			Bundle extras = getIntent().getExtras();
			mCodiclie = extras != null ? extras.getLong(ClienteDBAdapter.CODICLIE)
									: null;
		}

        mCodiclieText      = (TextView) findViewById(R.id.cliente_codiclie);
        mGrabaText         = (TextView) findViewById(R.id.cliente_graba);
   	    mDescripcionText   = (TextView) findViewById(R.id.cliente_descripcion);
    	mTitularText       = (TextView) findViewById(R.id.cliente_titular);
    	mCodigoPostalText = (TextView) findViewById(R.id.cliente_codigo_postal);
    	mPoblacionText     = (TextView) findViewById(R.id.cliente_poblacion);
    	mTelefono1Text     = (TextView) findViewById(R.id.cliente_telefono1);
    	mTelefono2Text     = (TextView) findViewById(R.id.cliente_telefono2);
    	mObservacion1Text  = (TextView) findViewById(R.id.cliente_observacion1);
    	mObservacion2Text  = (TextView) findViewById(R.id.cliente_observacion2);
    	mMensajeText       = (TextView) findViewById(R.id.cliente_mensaje);
    	mIncidenciaText    = (TextView) findViewById(R.id.cliente_incidencia);
    	mIncidenciaTmpText = (TextView) findViewById(R.id.cliente_incidenciatmp);
        
		populateFields();
    }

    public void onDestroy() {
    	super.onDestroy();

    	mDbHelper.close();
    }

/*    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_cliente_view, menu);
        return true;
    }
*/    

	private void populateFields() {
    	try{
            mCodiclieText.setText("");
       	    mDescripcionText.setText("");
        	mTitularText.setText("");
        	mCodigoPostalText.setText("");
        	mPoblacionText.setText("");
        	mTelefono1Text.setText("");
        	mTelefono2Text.setText("");
        	mObservacion1Text.setText("");
        	mObservacion2Text.setText("");
        	mIncidenciaText.setText("");
        	mGrabaText.setText("");
        	mMensajeText.setText("");
        	mIncidenciaTmpText.setText("");

        	if (mCodiclie != null) {
	            Cursor cliente  = mDbHelper.getCliente(mCodiclie.intValue());
	            Cursor fcli     = mDbHelper.getFcli(mCodiclie.intValue());
	            Cursor finci    = mDbHelper.getFinci(fcli.getString(fcli.getColumnIndexOrThrow(FcliDBAdapter.CODIINCI)));
	            Cursor fincitmp = mDbHelper.getFinci(fcli.getString(fcli.getColumnIndexOrThrow(FcliDBAdapter.CODIINCITMP)));
	            Cursor fmencli  = mDbHelper.getFmencli(fcli.getString(fcli.getColumnIndexOrThrow(FcliDBAdapter.CODIMCLI)));
	            
	            if (cliente.getCount() > 0){
		            mCodiclieText.setText(cliente.getString(cliente.getColumnIndexOrThrow(ClienteDBAdapter.CODICLIE)));
		       	    mDescripcionText.setText(cliente.getString(cliente.getColumnIndexOrThrow(ClienteDBAdapter.DESCRIPCION)));
		        	mTitularText.setText(cliente.getString(cliente.getColumnIndexOrThrow(ClienteDBAdapter.TITULAR)));
		        	mCodigoPostalText.setText(cliente.getString(cliente.getColumnIndexOrThrow(ClienteDBAdapter.CODPOSTAL)));
		        	mPoblacionText.setText(cliente.getString(cliente.getColumnIndexOrThrow(ClienteDBAdapter.POBLACION)));
		        	mTelefono1Text.setText(cliente.getString(cliente.getColumnIndexOrThrow(ClienteDBAdapter.TELEFONO1)));
		        	mTelefono2Text.setText(cliente.getString(cliente.getColumnIndexOrThrow(ClienteDBAdapter.TELEFONO2)));
	            }
	            cliente.close();
	            
	            if (fcli.getCount() > 0){
		        	mObservacion1Text.setText(fcli.getString(fcli.getColumnIndexOrThrow(FcliDBAdapter.OBSERVACION1)));
		        	mObservacion2Text.setText(fcli.getString(fcli.getColumnIndexOrThrow(FcliDBAdapter.OBSERVACION2)));
	            }
	            fcli.close();
		        	
	            if (finci.getCount() > 0){
		        	mIncidenciaText.setText(finci.getString(finci.getColumnIndexOrThrow(FinciDBAdapter.DESCINCI)));
		        	mGrabaText.setText(finci.getString(finci.getColumnIndexOrThrow(FinciDBAdapter.GRABA)));
	            }
	            finci.close();
		        	
	            if (fmencli.getCount() > 0){
		        	mMensajeText.setText(fmencli.getString(fmencli.getColumnIndexOrThrow(FmencliDBAdapter.DESCMCLI)));
	            }
	            fmencli.close();
		        	
	            if (fincitmp.getCount() > 0){
		        	mIncidenciaTmpText.setText(fincitmp.getString(fincitmp.getColumnIndexOrThrow(FinciDBAdapter.DESCINCI)));
	            }
	            fincitmp.close();
	        }
    	}
    	catch (Exception e){
    		return;
    	}
    	
    }
}
