package com.ventas.pedidoscomercial;

import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.graphics.PorterDuff;

public class MainActivity extends Activity {

	//Operacin de sincronizacin: IMPORTACION_COMPLETA, IMPORTACION_PARCIAL, ENVIO_PEDIDOS
	public final static String ENVIO_DE_PEDIDOS           = "ENVIO DE PEDIDOS";
	public final static String IMPORTACION_COMPLETA       = "IMPORTACION COMPLETA";
	public final static String IMPORTACION_PARCIAL        = "IMPORTACION PARCIAL";
	public final static int    COLOR_ROJO                 = 0xFFFF0000;
	public final static int    COLOR_VERDE                = 0xFF008000;
	public final static int    COLOR_AZUL                 = 0xFF000080;
	public       static String OPERACION_SYNC;
	public       static int    COLOR_BASE;
	public       static int    COLOR_IMPORTACION_COMPLETA;
	public       static int    COLOR_IMPORTACION_PARCIAL;
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	Button btAux;
    	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

    	COLOR_BASE                 = COLOR_ROJO;
    	COLOR_IMPORTACION_COMPLETA = COLOR_VERDE;
    	COLOR_IMPORTACION_PARCIAL  = COLOR_AZUL;

    	btAux = (Button) findViewById(R.id.button_crear_pedidos);
        btAux.getBackground().setColorFilter(COLOR_BASE, PorterDuff.Mode.MULTIPLY);

        btAux = (Button) findViewById(R.id.button_ver_pedidos);
        btAux.getBackground().setColorFilter(COLOR_BASE, PorterDuff.Mode.MULTIPLY);

        btAux = (Button) findViewById(R.id.button_ver_clientes);  
        btAux.getBackground().setColorFilter(COLOR_BASE, PorterDuff.Mode.MULTIPLY);

        btAux = (Button) findViewById(R.id.button_ver_articulos);  
        btAux.getBackground().setColorFilter(COLOR_BASE, PorterDuff.Mode.MULTIPLY);

        btAux = (Button) findViewById(R.id.button_enviar_pedidos);
        btAux.getBackground().setColorFilter(COLOR_BASE, PorterDuff.Mode.MULTIPLY);

        btAux = (Button) findViewById(R.id.button_importacion_completa);
        btAux.getBackground().setColorFilter(COLOR_BASE, PorterDuff.Mode.MULTIPLY);

        btAux = (Button) findViewById(R.id.button_importacion_parcial);
        btAux.getBackground().setColorFilter(COLOR_BASE, PorterDuff.Mode.MULTIPLY);
        
        //ESTA PARTE ES SOLO PARA LA IMPORTACION LOCAL A MODO DEMO
        //PENDIENTE DE BORRAR
        btAux = (Button) findViewById(R.id.button_importacion_completa_local);
        btAux.getBackground().setColorFilter(COLOR_BASE, PorterDuff.Mode.MULTIPLY);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
    
    /** Called when the user clicks the crearPedidos button */
    public void crearPedidos(View view) {
        // Do something in response to button
    	Intent intent = new Intent(this, NewPedido.class);
    	startActivity(intent);
    }

    /** Called when the user clicks the verPedidos button */
    public void verPedidos(View view) {
        // Do something in response to button
    	Intent intent = new Intent(this, Pedidos.class);
    	startActivity(intent);
    }

    /** Called when the user clicks the verClientes button */
    public void verClientes(View view) {
        // Do something in response to button
    	Intent intent = new Intent(this, ClienteListActivity.class);
    	intent.putExtra("PERMITE_NAVEGACION", "SI");
    	startActivity(intent);
    }

    /** Called when the user clicks the verClientes button */
    public void verArticulos(View view) {
        // Do something in response to button
    	Intent intent = new Intent(this, ArticuloListActivity.class);
    	intent.putExtra("PERMITE_NAVEGACION", "SI");
    	startActivity(intent);
    }

    /** Called when the user clicks the enviarPedidos button */
    public void enviarPedidos(View view) {
        // Do something in response to button
    	Intent intent = new Intent(this, SyncActivity.class);
    	intent.putExtra(OPERACION_SYNC, ENVIO_DE_PEDIDOS);
    	startActivity(intent);
    }

    /** Called when the user clicks the importacionCompleta button */
    public void importacionCompleta(View view) {
        // Do something in response to button
    	Intent intent = new Intent(this, SyncActivity.class);
    	intent.putExtra(OPERACION_SYNC, IMPORTACION_COMPLETA);
    	startActivity(intent);
    }

    /** Called when the user clicks the importacionParcial button */
    public void importacionParcial(View view) {
        // Do something in response to button
    	Intent intent = new Intent(this, SyncActivity.class);
    	intent.putExtra(OPERACION_SYNC, IMPORTACION_PARCIAL);
    	startActivity(intent);
    }
    
    //ESTA PARTE ES SOLO PARA LA IMPORTACION LOCAL A MODO DEMO
    //PENDIENTE DE BORRAR
    public void importacionCompletaLocal(View view) {
        // Do something in response to button
    	Intent intent = new Intent(this, SyncActivity.class);
    	intent.putExtra(OPERACION_SYNC, "IMPORTACION COMPLETA LOCAL");
    	startActivity(intent);
    }
}
