package com.ventas.pedidoscomercial;

import com.ventas.database.ArtibarDBAdapter;
import com.ventas.database.ArticuloDBAdapter;
import com.ventas.database.ClienteDBAdapter;
import com.ventas.database.DBAdapter;
import com.ventas.database.FclespDBAdapter;
import com.ventas.database.FcliDBAdapter;
import com.ventas.database.FcloferDBAdapter;
import com.ventas.database.FcomespDBAdapter;
import com.ventas.database.FmenartDBAdapter;
import com.ventas.database.FpevtcbDBAdapter;
import com.ventas.database.FpevtlnDBAdapter;
import com.ventas.database.UnidadDBAdapter;
import com.ventas.database.UprecioDBAdapter;

import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.Menu;
import android.view.View;
import android.view.WindowManager;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.SimpleCursorAdapter;
import android.widget.Spinner;
import android.widget.TextView;

public class Pedidoln extends Activity {

	private final int REQUEST_ARTICULO = 2;
	private final int REQUEST_MENART = 11;

	private DBAdapter 	mDbHelper; 
	private long 	cliente;
	private String	fechaped;

	private long   codipeln;
	private long   codipecb;
	private String codigobarras = "";
	
	private EditText  	mCodiarti;
	private TextView  	mDescarti;
	private EditText  	mCodimart;
	private EditText  	mCantidad;
	private Spinner     mCantenvo;
	private Spinner     mCodiunid;
	private EditText  	mPrecio;
	private EditText  	mTextmart;
	private TextView  	mTipoprecio;
	private TextView  	mLineas;
		
	private Button  	mUprecio;
	private TextView  	mInfo;
	
	private boolean 	pintaInfo = true;
	private double   	prectariactu;
	private boolean     mensamod = false;
	
	//private boolean		BloqEven = false;
	private boolean 	boError = false;
	private String 		stError = null;
	private int			ErControl;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pedidoln);

        try{
	        mDbHelper = new DBAdapter(this);
	        mDbHelper.open();
        }
        catch (Exception e){
        	return;
        }
        
		// capture our View elements
        mCantenvo = (Spinner) findViewById(R.id.peln_cantenvo); 
        mCodiunid = (Spinner) findViewById(R.id.peln_codiunid);
    	mCodiarti = (EditText) findViewById(R.id.peln_codiarti);
    	mDescarti = (TextView) findViewById(R.id.peln_descarti);
    	mCantidad = (EditText) findViewById(R.id.peln_cantidad);
    	mPrecio = (EditText) findViewById(R.id.peln_precio);
    	mTipoprecio = (TextView) findViewById(R.id.peln_tipoprecio);
    	mUprecio = (Button) findViewById(R.id.peln_btUprecio);
    	mCodimart = (EditText) findViewById(R.id.peln_codimart);
    	mTextmart = (EditText) findViewById(R.id.peln_textmart);
    	mInfo = (TextView) findViewById(R.id.peln_info);
        mLineas = (TextView) findViewById(R.id.peln_lineas);
    	
    	//Llena Spinners
        this.CargarSpUnid();
        
		if (savedInstanceState != null) {
			codipecb = savedInstanceState.getLong(FpevtlnDBAdapter.CODIPECB);
			codipeln = savedInstanceState.getLong(FpevtlnDBAdapter.CODIPELN);
			fechaped = savedInstanceState.getString(FpevtcbDBAdapter.FECHA);
			cliente = savedInstanceState.getLong(FpevtcbDBAdapter.CODICLIE);

		}
		else { 
			Bundle extras = getIntent().getExtras();
			if (extras != null) {
				codipecb = extras.getLong(FpevtlnDBAdapter.CODIPECB);
				codipeln = extras.getLong(FpevtlnDBAdapter.CODIPELN);
				fechaped = extras.getString(FpevtcbDBAdapter.FECHA);
				cliente = extras.getLong(FpevtcbDBAdapter.CODICLIE);

			}
			else {
				//System.out.println("Sin parametros");
				msboxFinish("Error en el acceso a los datos.");
			}
			
		}
		
		mCodiarti.addTextChangedListener(new TextWatcher(){

			public void afterTextChanged(Editable s) {
				// TODO Auto-generated method stub
				afterArticulo();
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

			public void onTextChanged(CharSequence s, int start, int before, int count) {}
			
		});
		mCantidad.addTextChangedListener(new TextWatcher(){

			public void afterTextChanged(Editable s) {
				// TODO Auto-generated method stub
	            pintaPedido();
				
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

			public void onTextChanged(CharSequence s, int start, int before, int count) {}
		});
		mPrecio.addTextChangedListener(new TextWatcher(){
			Double Precioant;
			
			public void afterTextChanged(Editable s) {
				// TODO Auto-generated method stub
				try {
					if (Precioant != Double.valueOf(mPrecio.getText().toString())) {
						mTipoprecio.setText("Personal");
						//this.btnNoApli.Visible = false;
					}
				}
				catch (Exception e) {
					
				}	
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) {
				try {
					Precioant = Double.valueOf(mPrecio.getText().toString());
				}
				catch(Exception e) {
					Precioant = 0.0;
				}
				
			}

			public void onTextChanged(CharSequence s, int start, int before, int count) {}
			
		});	
		mCantenvo.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				// TODO Auto-generated method stub
				double cantenvo;
				
				try {
					
					try {
						cantenvo = Double.valueOf(SpinerGetValorSelected(mCantenvo, ArtibarDBAdapter.CANTSTVT));
						codigobarras = SpinerGetValorSelected(mCantenvo, ArtibarDBAdapter.CODIGOBARRAS);
					}
					catch (Exception e) {
	                    mCodiunid.setSelected(false);
	                    mCodiunid.setEnabled(true);
						return;
					}
					
					if (cantenvo == 1) {
	                    mCodiunid.setSelection(0);
	                    mCodiunid.setEnabled(true);
					}
					else {
						Cursor cur = mDbHelper.getArtibar(codigobarras);
						if (cur.getCount() != 0) {
		                    mCodiunid.setSelection( SpinnerGetIndex(mCodiunid, cur.getString(cur.getColumnIndexOrThrow(ArtibarDBAdapter.CODIUNID))));
		                    mCodiunid.setEnabled(false);
						}
						else {
		                    mCodiunid.setSelection(0);
		                    mCodiunid.setEnabled(true);
						}
						cur.close();
					}
					
					pintaPedido();
				}
				catch (Exception e){
					msboxFinish("Error. Pulse Ok para salir.");
				}
			}

			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub
				codigobarras = "";
			}
		});
		mCodiunid.setOnItemSelectedListener(new Spinner.OnItemSelectedListener(){
			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				// TODO Auto-generated method stub
				pintaPedido();
			}

			public void onNothingSelected(AdapterView<?> arg0) {}
			
		});
	    mCodimart.addTextChangedListener(new TextWatcher(){

			public void afterTextChanged(Editable s) {
				// TODO Auto-generated method stub
				Cursor curm = mDbHelper.getFmenart(mCodimart.getText().toString());

				if (curm.getCount() > 0) {
					mTextmart.setText( curm.getString(curm.getColumnIndexOrThrow(FmenartDBAdapter.DESCMART)) );
					mensamod = false;
				}
				else {
					mTextmart.setText("");
				}
				curm.close();
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

			public void onTextChanged(CharSequence s, int start, int before, int count) {}
			
		});
	    mTextmart.addTextChangedListener(new TextWatcher(){

			public void afterTextChanged(Editable s) {
				mensamod = true;
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

			public void onTextChanged(CharSequence s, int start, int before, int count) {}
			
		});
		
		if (codipeln != 0) { //si es una modificacion de linea
		    //Llenar Datos
		    fillData();
		    getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
		}
		else { //si es una nueva linea
			reiniciar();
		}

    }

	
    @Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
    	mDbHelper.close();
    	
		super.onDestroy();
	}

    private void reiniciar() {
  	
	    mCodiarti.setText( "" );
		mCantidad.setText( "" );
		mPrecio.setText( "" );
		mCodimart.setText( "" );
		mTextmart.setText( "" );
		
		codigobarras = "";
		mCantenvo.setSelection(0);
		mCantenvo.setSelected(false);
		
    	mTipoprecio.setText("");
    	mTipoprecio.setTextColor(getResources().getColor(R.color.White));
			
	    mCodiunid.setSelection(0);
	    
	    Cursor curP = mDbHelper.getPevtlnByCB(codipecb);
	    mLineas.setText( String.valueOf(curP.getCount()) + " Lin / ped.");
	    
		mUprecio.setVisibility(View.GONE);
		mUprecio.setText("");
	    	
    }
    
	private void fillData() {
        try{
		    
		    reiniciar();
		    
		    //Asignar el cursor (con parametros
		    Cursor curdata = mDbHelper.getPevtln(codipeln);
		    //System.out.println(cur.getCount() + " Lineas en " + mCodipeln);
		    //BloqEven = true;
		    mCodiarti.setText( curdata.getString(curdata.getColumnIndexOrThrow(FpevtlnDBAdapter.CODIARTI)) );
		    afterArticulo();
			//afterArticulo();
			mCantidad.setText( curdata.getString(curdata.getColumnIndexOrThrow(FpevtlnDBAdapter.CANTIDAD)) );
			mPrecio.setText( curdata.getString(curdata.getColumnIndexOrThrow(FpevtlnDBAdapter.PRECIO)) );
			
	        //para mensaje de articulo
	        String lcodimart = curdata.getString(curdata.getColumnIndexOrThrow(FpevtlnDBAdapter.CODIMART));
	        String ltextmart = curdata.getString(curdata.getColumnIndexOrThrow(FpevtlnDBAdapter.TEXTMART));
	        if (ltextmart.equals("")){
	        	mCodimart.setText(lcodimart);
	        	mensamod = false;
	        }
	        else {
	        	mTextmart.setText( ltextmart );
		        mensamod = true;
	        }
			
			codigobarras = curdata.getString(curdata.getColumnIndexOrThrow(FpevtlnDBAdapter.CODIGOBARRAS));
			mCantenvo.setSelection(SpinnerGetIndex(mCantenvo, codigobarras ));
			
	    	mTipoprecio.setText( curdata.getString(curdata.getColumnIndexOrThrow(FpevtlnDBAdapter.TIPOPRECIO)) );
	    	mTipoprecio.setTextColor(getResources().getColor(R.color.White));
	    	
	    	//mUprecio.setText("");
	    	
	    	curdata.close();
	    	
	    	pintaPedido();
  	    
        }
        catch (Exception e){
        		msboxFinish("Error en el acceso a los datos.");
        }
    }

	
	private void afterArticulo(){

		Cursor curart = mDbHelper.getArticulo(mCodiarti.getText().toString());
		if (curart.getCount() > 0) {
			mDescarti.setText( curart.getString(curart.getColumnIndexOrThrow(ArticuloDBAdapter.DESCARTI)) );
			this.CargarSpEnvo(mCodiarti.getText().toString());
			if (codigobarras != "") {
				mCantenvo.setSelection(SpinnerGetIndex(mCantenvo, codigobarras ));
			}
			pintaPrecio();
			//mCodiarti.requestFocus(View.FOCUS_DOWN);
			mCantidad.requestFocus(View.FOCUS_DOWN);
		}
		else {
			mDescarti.setText("");
		}
		curart.close();
	}
	
	
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //getMenuInflater().inflate(R.menu.activity_pedidoln, menu);
        return true;
    }
    
    public void CargarSpUnid() {
        
      //Creamos el cursor
        Cursor curUnid = mDbHelper.getUnidad();
        startManagingCursor(curUnid);
        
        String[] from = new String[] { 	UnidadDBAdapter.CODIUNID,
        								UnidadDBAdapter.DESCUNID}; 
		int[] to = new int[] { 	android.R.id.text1,
								android.R.id.text2};

        
		//Creamos el adaptador
		SimpleCursorAdapter adapter = new SimpleCursorAdapter(this, android.R.layout.simple_spinner_item, curUnid , from,  to); 
		//Aadimos el layout para el men
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		//Le indicamos al spinner el adaptador a usar
		mCodiunid.setAdapter(adapter);
    }
    
    public void CargarSpEnvo(String codiarti) {
        
    	//Creamos el cursor
        Cursor curEnvo = mDbHelper.getArtibarByCodiarti(codiarti);
        startManagingCursor(curEnvo);
          
        String[] from = new String[] { 	ArtibarDBAdapter.CANTSTVT,
	        		  					ArtibarDBAdapter.CODIGOBARRAS,}; 
  		int[] to = new int[] { 	android.R.id.text1,
  								android.R.id.text2};

          
  		//Creamos el adaptador
  		SimpleCursorAdapter adapter = new SimpleCursorAdapter(this, android.R.layout.simple_spinner_item, curEnvo , from,  to); 
  		//Aadimos el layout para el men
  		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
  		//Le indicamos al spinner el adaptador a usar
  		mCantenvo.setAdapter(adapter);
    }

	//Calcula el indice del Spinner segun String
	public int SpinnerGetIndex(Spinner s1, String valor){

        int index = 0;

        for (int i=0; i < s1.getCount(); i++){
        	Cursor value = (Cursor) s1.getItemAtPosition(i);
        	String id = value.getString(value.getColumnIndex("_id"));
        	//System.out.println(id);
            if (id.equals(valor)){
                index = i;
                break;
            }
        }
        return index;
	}

	//Calcula el indice del Spinner segun String
	private String SpinerGetValorSelected(Spinner s1, String campo){
    	Cursor value = (Cursor) s1.getSelectedItem();
    	return value.getString(value.getColumnIndex(campo));
	}

	private void CalculaPrecioTarifa()
	{
		Cursor cur = mDbHelper.getArticulo(mCodiarti.getText().toString());
		try
		{
			if (cur.getCount() != 0) {
				prectariactu = cur.getDouble(cur.getColumnIndexOrThrow(ArticuloDBAdapter.PRECTARI)); 
			}
		}
		catch (Exception e)
		{
			prectariactu = 0;
		}
		cur.close();
    }
	
	private void pintaPrecio() {
		
		Cursor curPre;
		
		mTipoprecio.setText("");
		mPrecio.setEnabled(false);

		try
		{
			CalculaPrecioTarifa();

			//Pintar el ltimo precio aplicado
			PintaPrecioUltimo(cliente, mCodiarti.getText().toString());

			//Primera prioridad: PRECIO OFERTA
			curPre = mDbHelper.getFclofer(fechaped, cliente, mCodiarti.getText().toString());
			if (curPre.getCount() > 0) {
				mTipoprecio.setText("Oferta");
				mTipoprecio.setTextColor(getResources().getColor(R.color.LightGreen));
				mPrecio.setText( curPre.getString(curPre.getColumnIndexOrThrow(FcloferDBAdapter.PRECCOFE)) );
				//this.btnNoApli.Visible         = true;
				mPrecio.setEnabled(true);
				curPre.close();
				return;
			}
			curPre.close();
			
			//Segunda prioridad: CLIENTE ESPECIAL
			curPre = mDbHelper.getFclesp(fechaped, cliente, mCodiarti.getText().toString());
			if (curPre.getCount() > 0) {
				mTipoprecio.setText("Cliente especial");
				mTipoprecio.setTextColor(getResources().getColor(R.color.LightGreen));
				mPrecio.setText( curPre.getString(curPre.getColumnIndexOrThrow(FclespDBAdapter.PRECIO)) );
				mPrecio.setEnabled(true);	
				curPre.close();
				return;
			}
			curPre.close();
			
			//Tercera prioridad: PRECIO COMERCIO
			curPre = mDbHelper.getFcli(cliente);
			String codicome = curPre.getString(curPre.getColumnIndexOrThrow(FcliDBAdapter.CODICOME));
			if (codicome != "") {
				curPre = mDbHelper.getFcomesp(fechaped, codicome, mCodiarti.getText().toString());
				if (curPre.getCount() > 0) {
					mTipoprecio.setText("Comercio");
					mTipoprecio.setTextColor(getResources().getColor(R.color.LightGreen));
					mPrecio.setText( curPre.getString(curPre.getColumnIndexOrThrow(FcomespDBAdapter.PRECIO)) );
					mPrecio.setEnabled(true);	
					curPre.close();
					return;
				}
			}
			curPre.close();
			
			//Cuarta prioridad: PRECIO TARIFA
			mPrecio.setText(String.valueOf(prectariactu));
			mTipoprecio.setText("Tarifa");
			mTipoprecio.setTextColor(getResources().getColor(R.color.LightGreen));
			
		}
		catch (Exception e)
		{
			msboxFinish("Error. Pulse Ok para salir.");
			mPrecio.setEnabled(true);	
		}
		mPrecio.setEnabled(true);	
    }


	
	private boolean ValidarFicha() {
		double cantidad = 0;
		double precio = 0;
		double Aux;
		int    linAux;

		boError = false;

		//Validar el artculo
		this.ValidarArticulo();

		//Verificar que la cantidad es decimal.
		if (!boError) {
			try	{
				cantidad = Double.valueOf(mCantidad.getText().toString());
			}
			catch(Exception e){
				boError = true;
				stError = "La cantidad no es correcta.";
				ErControl = R.id.peln_cantidad;
			}
		}

		//Verificar que la cantidad es mayor que cero.
		if (!boError) {
			if (cantidad <= 0) {
				boError = true;
				stError = "La cantidad debe ser MAYOR que 0.";
				ErControl = R.id.peln_cantidad;
			}
		}

		//Verificar que si se vende cajas, la cantidad no puede ser decimal
		try {
			//ldbAux = Double.Parse(cboEnvo.Text);
			Aux = Double.valueOf(this.SpinerGetValorSelected(this.mCantenvo, ArtibarDBAdapter.CANTSTVT));
			if (Aux > 1) { //Envoltorio que contiene ms de una unidad
				//ldbAux = Double.Parse(txtCantidad.Text);
				Aux = cantidad;
				linAux = (int) Aux;

				if ((Aux - linAux) != 0) {
					boError = true;
					stError = "Si vende cajas, la cantidad no puede ser decimal.";
					ErControl = R.id.peln_cantidad;
				}
			}
			else {
				if (Aux == 1) { //Envoltorio que contiene ms de una unidad
					if (mCantenvo.getCount() > 0) {
					}
				}
			}
		}
		catch (Exception e) {
		}

		//Verificar que el precio es decimal.
		if (!boError) {
			try	{
				precio = Double.valueOf(mPrecio.getText().toString());
			}
			catch (Exception e) {
				boError = true;
				stError = "El precio no es correcto.";
				ErControl = R.id.peln_precio;
			}
		}

		//Verificar que el precio es mayor que cero.
		if (!boError) {
			if (precio <= 0) {
				boError = true;
				stError = "El precio debe ser MAYOR que 0.";
				ErControl = R.id.peln_precio;
			}
		}

		//Verificar que el precio no supera el doble del precio tarifa.
		if ((!boError) && (prectariactu > 0)) {
			if (precio > (prectariactu*2)) {
				boError = true;
				stError = "El precio supera el 100% del precio tarifa.";
				ErControl = R.id.peln_precio;
			}
		}

		//Validar cdigo de unidad
		if (!boError) {
			if (mCodiunid.getSelectedItem() == null) {
				boError = true;
				stError = "Debe seleccionar una unidad.";
				ErControl = R.id.peln_codiunid;
			}
		}

		//Tratamiento en caso de error
		if (boError) {
	        AlertDialog.Builder dlgAlert  = new AlertDialog.Builder(this);                       
	        dlgAlert.setMessage(stError);  
	        dlgAlert.setTitle("Error de validacin");
	        dlgAlert.setPositiveButton("Aceptar",new DialogInterface.OnClickListener() { 
	            public void onClick(DialogInterface dialog, int whichButton) {
	            	
	    			switch (ErControl) {
					case R.id.peln_codiunid:  //Seleccin operacin
						//mCodiunid.setFocusableInTouchMode(true);
						mCodiunid.requestFocus();
						break;
					default:
						TextView lControl = (TextView) findViewById(ErControl);
						//lControl.setFocusableInTouchMode(true);
						lControl.requestFocus();
	    			}
	            	
	            } 
	       }); 

	        dlgAlert.setCancelable(true); 
	        dlgAlert.create().show(); 

		}

		return !boError;
	}

	private boolean ValidarArticulo()
	{

		//Validar que el cdigo del artculo no est vaco:
		if (mCodiarti.getText().toString() == "" | mCodiarti.getText().toString() == null) {
			boError = true;
			stError = "Debe introducir un artculo";
			ErControl = R.id.peln_codiarti;
		}
		
		//Verificar que el artculo existe.
		if (!boError) {
			Cursor cur = mDbHelper.getArticulo(mCodiarti.getText().toString());
			if (cur.getCount()==0) {
				boError = true;
				stError = "El artculo no existe en la base de datos.";
				ErControl = R.id.peln_codiarti;
			}
		}

		return !boError;
	}

	
	private void PintaPrecioUltimo(long pcodiclie, String pcodiarti) {

		try {
			Cursor curUp = mDbHelper.getUprecio(pcodiclie, pcodiarti);

			if (curUp.getCount() == 1) {
				mUprecio.setVisibility(View.VISIBLE);
				mUprecio.setText(curUp.getString(curUp.getColumnIndexOrThrow(UprecioDBAdapter.PRECIO)));
				curUp.close();
			}
			else {
				mUprecio.setVisibility(View.GONE);
				mUprecio.setText("");
			}
		}
		catch(Exception e) {
		}

    }

	private void pintaPedido() {
		double cantenvo;
		double cantidad;
		String codiunid;

		try {
			if (!pintaInfo) 
				return;

			mInfo.setText("");

			if (mCodiunid.getSelectedItem() == null) {
				return;
			}

			cantenvo = Double.valueOf(this.SpinerGetValorSelected(this.mCantenvo, ArtibarDBAdapter.CANTSTVT));
			codiunid = SpinerGetValorSelected(mCodiunid, UnidadDBAdapter.CODIUNID);
			
			if (cantenvo == 1) {
				if (codiunid == "UND") {
					mInfo.setText(mCantidad.getText().toString() + " " + codiunid + " SUELTAS.");
				}
				else {
					mInfo.setText(mCantidad.getText().toString() + " " + codiunid + " SUELTOS.");
				}
			}
			else {
				cantidad = Double.valueOf( mCantidad.getText().toString() );
				mInfo.setText(String.valueOf(cantidad * cantenvo) + " " + codiunid + " en cajas de " + String.valueOf(cantenvo) + " " + codiunid);
			}
		}
		catch (Exception e) {
			return;
		}
    }

	public boolean ConvierteCajas() {
		
		//Si solo existe el formato unidad, no convertir a cajas
		if (this.mCantenvo.getCount() <= 1) {
			return true;
		}
	
		//Si el usuario ha seleccionado cajas, no convertir.
		double cantenvo = Double.valueOf(this.SpinerGetValorSelected(this.mCantenvo, ArtibarDBAdapter.CANTSTVT)) ;
		if (cantenvo > 1) {
			return true; 
		}
		
		pintaInfo = false;
	
		//Si la cantidad solicitada es mltiplo del contenido de algn formato de caja, traducir.
		final double cantenvoini = cantenvo;
		final String unidadini = SpinerGetValorSelected(mCodiunid, UnidadDBAdapter.CODIUNID).trim();
		final double ldbCantidad  = Double.valueOf(this.mCantidad.getText().toString());
		
		for (int i=this.mCantenvo.getCount(); i>0; i--) {
			this.mCantenvo.setSelection(i-1);
			final double ldbCantenvo = Double.valueOf(this.SpinerGetValorSelected(this.mCantenvo, ArtibarDBAdapter.CANTSTVT)) ;
	
			if (ldbCantenvo == 1)
			{
				this.mCodiunid.setSelection(this.SpinnerGetIndex(this.mCodiunid, unidadini));
				return true;
			}
	
			//Seleccionar el formato si la cantidad solicitada es mayor o igual a la cantidad de envoltorio.
			if (ldbCantidad >= ldbCantenvo) {
				String lStunidad = SpinerGetValorSelected(mCodiunid, UnidadDBAdapter.CODIUNID).trim();			
				if ( unidadini.equals(lStunidad) ) {
					//Si la cantidad pedida es mltiplo del contenido del formato, traducir a caja
					if ((ldbCantidad % ldbCantenvo) == 0) {
						double ldbCajas = ldbCantidad / ldbCantenvo;
	
						this.mInfo.setText( String.valueOf(ldbCantidad) + unidadini +
							" en " + String.valueOf(ldbCajas) + " cajas de " + String.valueOf(ldbCantenvo) + " " + String.valueOf(this.mCodiunid.getSelectedItemId()) );
	
						String lstMsg = "Se servir " + String.valueOf(ldbCantidad) + " " + unidadini + 
							" en " + String.valueOf(ldbCajas) + " cajas de " + String.valueOf(ldbCantenvo) + " " + String.valueOf(this.mCodiunid.getSelectedItemId());

				    	AlertDialog.Builder yesandno = new AlertDialog.Builder(this);   
				    	
				    	yesandno
				    		.setIcon(android.R.drawable.ic_dialog_dialer)
				    		.setTitle("Est conforme?")
				    		.setMessage(lstMsg + ". Est conforme?")
				        	.setPositiveButton("Si", new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int id) {
				        	        // User clicked Si
									afterAceptar();
				        	    }
				        	})
				        	.setNegativeButton("No", new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int id) {
				        	        // User clicked no
									mCantidad.setText(String.valueOf( ldbCantidad ));
				        	    	mCantenvo.setSelection( SpinnerGetIndex(mCantenvo, String.valueOf( cantenvoini)) );
									mCodiunid.setSelection(SpinnerGetIndex(mCodiunid, unidadini));
									pintaInfo = true;
									pintaPedido();
									afterAceptar();
				        	    }
				        	})

				    		.show();
						
						this.mCantidad.setText(String.valueOf(ldbCajas));
						//this.mstLinePedi.cantidad = this.ConvertToDouble((ldbCajas).ToString("N", nfiCant));
						pintaInfo = true;
						return false;
					}
				}
			}
		}
		pintaInfo = true;
		return false;
	}


    /** Called when the user clicks the buscarArticulo button */
    public void buscarArticulo(View view) {
        Intent intent = new Intent(this, ArticuloListActivity.class);
    	intent.putExtra("PERMITE_NAVEGACION", "NO");
    	startActivityForResult(intent, REQUEST_ARTICULO);
    }
    
    /** Called when the user clicks the buscarMensaje button */
    public void buscarMensaje(View view) {
        Intent intent = new Intent(this, MenListActivity.class);
    	intent.putExtra("TABLA", REQUEST_MENART);
    	startActivityForResult(intent, REQUEST_MENART);
    }
    
    public void onUprecio(View view) {
    	mPrecio.setText(mUprecio.getText().toString());
    	mPrecio.requestFocus();
    	mPrecio.setSelection(0, mPrecio.getText().toString().length());
    }
    
    public void onAceptar(View view) {
    	
		if (!ValidarFicha())
			return;
		
		if (ConvierteCajas())
			afterAceptar();
    }
    
    public void afterAceptar() {
		// TODO Auto-generated method stub
		double cantenvo = 0;
		double canttota;
		double cantcaja;
    	String lstCodimart = "";
    	String lstTextmart = "";

		try
		{

			//Capturar el envoltorio, cdigo de unidad, tipo de lnea, cdigo del mensaje y texto del mensaje.
			if (!boError) {

				codigobarras = "";
				if ( mCantenvo.getSelectedItem() != null) {
					cantenvo = Double.valueOf(SpinerGetValorSelected(mCantenvo, ArtibarDBAdapter.CANTSTVT));
					codigobarras = SpinerGetValorSelected(mCantenvo, ArtibarDBAdapter.CODIGOBARRAS);
				}

		        if (!mensamod) { //NO se ha modificado el texto de mensaje de articulo
		        	lstCodimart = mCodimart.getText().toString();
		        	lstTextmart = "";
		        }
		        else { //SI se ha modificado el texto de mensaje de articulo
		        	lstCodimart = "";
		        	lstTextmart = mTextmart.getText().toString();
		        }
		        
			}

			canttota = Double.valueOf( mCantidad.getText().toString() );

			try {
				if (codigobarras != "") {
					cantcaja = cantenvo;
					canttota = canttota * cantcaja;
				}
			}
			catch (Exception e) {
			}

			
			if (codipeln !=0) {
				//La lnea se ha modificado y hay que actualizarla.
				if (mDbHelper.updateFpevtln(codipeln, 
											codipecb, 
											mCodiarti.getText().toString(), 
											lstCodimart, 
											Double.valueOf( mCantidad.getText().toString() ), 
											Double.valueOf( mPrecio.getText().toString() ), 
											lstTextmart, 
											SpinerGetValorSelected(mCodiunid, UnidadDBAdapter.CODIUNID), 
											mDescarti.getText().toString(), 
											mTipoprecio.getText().toString(), 
											codigobarras, 
											canttota)) {
					updateUprecio();
					finish();  
				}
			}
			else {
				//La lnea es nueva y se debe de insertar.
				if (mDbHelper.createFpevtln(codipecb, 
										mCodiarti.getText().toString(), 
										lstCodimart, 
										Double.valueOf( mCantidad.getText().toString() ), 
										Double.valueOf( mPrecio.getText().toString() ), 
										lstTextmart, 
										SpinerGetValorSelected(mCodiunid, UnidadDBAdapter.CODIUNID), 
										mDescarti.getText().toString(), 
										mTipoprecio.getText().toString(), 
										codigobarras, 
										canttota) != -1) {
					updateUprecio();
					reiniciar();
					mCodiarti.requestFocus();
				}
			}
			
		}

		catch (Exception e) {
			msboxFinish("Error. Pulse Ok para salir.");
		}

    }

    private void updateUprecio(){
    	//Almacenar el precio aplicado como ltimo precio aplicado
    	boolean modi = mDbHelper.updateUprecio(cliente, mCodiarti.getText().toString() , Double.valueOf( mPrecio.getText().toString() ));
    	if (!modi) {
    		mDbHelper.createUprecio(cliente, mCodiarti.getText().toString() , Double.valueOf( mPrecio.getText().toString() ));
    	}
    }
	
    public void onVerPrecios(View view){
        Intent intent = new Intent(this, ArticuloPrecios.class);
    	String lCodiarti = mCodiarti.getText().toString();

        intent.putExtra("VIGENCIA", fechaped );
        intent.putExtra(ArticuloDBAdapter.DATABASE_TABLE, lCodiarti);
        intent.putExtra(ClienteDBAdapter.DATABASE_TABLE, String.valueOf(cliente));
        startActivity(intent);
    }

    
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    	try{
	        if (resultCode == RESULT_OK) {
	    	    switch (requestCode) {
	    	    	case REQUEST_ARTICULO:
			            if (data.hasExtra("ARTICULO_KEY")) {
			        		//Lo devuelto en la bsqueda de artculo, lo metemos en su editText para que el evento
			            	mCodiarti.setText(data.getExtras().getString("ARTICULO_KEY"));
			            }
	    	    		break;
	    	    	case REQUEST_MENART:
			            if (data.hasExtra("MENSAJE")) {
			        		//Lo devuelto en la bsqueda de mensaje, lo metemos en su editText para que el evento
			            	mCodimart.setText( data.getExtras().getString("MENSAJE") );
			            }
	    	    		break;
	    	    }
	        }
    	}
    	catch (Exception e){
    		msboxFinish("Error en la bsqueda.");
    	}
    }
    
    @Override
    public void finish() {
		//cerrar el teclado
    	InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
    	imm.hideSoftInputFromWindow( mCodiarti.getWindowToken(), 0);
    	
		setResult(RESULT_OK);
		super.finish();
    } 
	
	public void msboxFinish(String str) 
    { 
        AlertDialog.Builder dlgAlert  = new AlertDialog.Builder(this);                       
        dlgAlert.setMessage(str);  
        dlgAlert.setPositiveButton("Aceptar",new DialogInterface.OnClickListener() { 
            public void onClick(DialogInterface dialog, int whichButton) {
                finish();  
            } 
       }); 

        dlgAlert.setCancelable(true); 
        dlgAlert.create().show(); 
    } 
	
}
