package com.ventas.pedidoscomercial;


import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import com.ventas.database.ArticuloDBAdapter;
import com.ventas.database.ClienteDBAdapter;
import com.ventas.database.DBAdapter;
import com.ventas.database.FcliDBAdapter;
import com.ventas.database.FinciDBAdapter;
import com.ventas.database.FmencliDBAdapter;
import com.ventas.database.FpevtcbDBAdapter;
import com.ventas.database.FpevtlnDBAdapter;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.ContextMenu;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.Animation;
import android.view.animation.TranslateAnimation;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;
import android.widget.ViewFlipper;
import android.widget.AdapterView.AdapterContextMenuInfo;


public class Pedidos extends Activity {
	
	private final int DATE_DIALOG_ID = 0;
	private final int REQUEST_PELN  = 1;
	private final int REQUEST_MENCLI = 10;
	
	private int mYear;
    private int mMonth;
    private int mDay;
    private Date dtDate;
    
    private static final int INSERTLN_ID = Menu.FIRST;
    private static final int UPDATELN_ID = Menu.FIRST + 1;
    private static final int DELETELN_ID = Menu.FIRST + 2;
    
	private Long      	mCodipecb;
	private DBAdapter 	mDbHelper; 
	private Cursor 		mCurPcb;

	private TextView  mpecb_fechaText;
	private TextView  mpecb_cliText;
	private TextView  mpecb_descText;
	private TextView  mpecb_obs1Text;
	private TextView  mpecb_obs2Text;
	private TextView  mpecb_inciText;
	private EditText  mpecb_mcliText;
	private EditText  mpecb_tmcliText;
	private TextView  mpecb_pdpsText;
	private ListView  mPedidoRow;
	private Button	  mBtAceptar;
	
	private long lcliente = 0;
	private String	  mGraba;
	private boolean mensamod = false;
	
    public float init_x;
    private ViewFlipper vf;
	  

    public void onCreate(Bundle savedInstanceState){
		super.onCreate(savedInstanceState);
		
	    setContentView(R.layout.activity_pedidos);
	    
        try{
	        mDbHelper = new DBAdapter(this);
	        mDbHelper.open();
        }
        catch (Exception e){
        	return;
        }
        
            
		// capture our View elements
	    vf = (ViewFlipper) findViewById(R.id.viewFlipper1);
		mpecb_fechaText = (TextView) findViewById(R.id.pecb_fecha);
		mpecb_cliText = (TextView) findViewById(R.id.pecb_cliente);
		mpecb_descText = (TextView) findViewById(R.id.pecb_descripcion);
		mpecb_obs1Text = (TextView) findViewById(R.id.pecb_obs1);
		mpecb_obs2Text = (TextView) findViewById(R.id.pecb_obs2);
		mpecb_inciText = (TextView) findViewById(R.id.pecb_incidencia);
		mpecb_mcliText = (EditText) findViewById(R.id.pecb_codimcli);
		mpecb_tmcliText = (EditText) findViewById(R.id.pecb_textmcli);
		mpecb_pdpsText = (TextView) findViewById(R.id.pecb_pdps);
		mPedidoRow = (ListView) findViewById(R.id.pecb_row);
		mBtAceptar = (Button) findViewById(R.id.pecb_btAceptar);
		
        registerForContextMenu(mPedidoRow);
		
	    vf.setOnTouchListener(new ListenerTouchViewFlipper());
	    
	    //Al pulsar en fecha mostrar el DatePicker
	    mpecb_fechaText.setOnClickListener(new View.OnClickListener() {
			
			@SuppressWarnings("deprecation")
			public void onClick(View v) {
				showDialog(DATE_DIALOG_ID);
			}

			
		});
	    
	    mpecb_mcliText.addTextChangedListener(new TextWatcher(){

			public void afterTextChanged(Editable s) {
				// TODO Auto-generated method stub
				Cursor curm = mDbHelper.getFmencli(mpecb_mcliText.getText().toString());
				if (curm.getCount() > 0) {
					mpecb_tmcliText.setText( curm.getString(curm.getColumnIndexOrThrow(FmencliDBAdapter.DESCMCLI)) );
					mensamod = false;
					mBtAceptar.setVisibility(View.VISIBLE);
				}
				else {
					mpecb_tmcliText.setText("");
				}
				curm.close();
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

			public void onTextChanged(CharSequence s, int start, int before, int count) {}
			
		});
	    mpecb_tmcliText.addTextChangedListener(new TextWatcher(){

			public void afterTextChanged(Editable s) {
				mensamod = true;
				mBtAceptar.setVisibility(View.VISIBLE);
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

			public void onTextChanged(CharSequence s, int start, int before, int count) {}
			
		});
		
	    mPedidoRow.setOnItemClickListener(new ListView.OnItemClickListener(){

	    	   public void onItemClick(AdapterView<?> adapter, View view, int position, long id) {
	    		   UpdateLn(id);
	    	   }

	    });
	
		String lfecha;
	   
		if (savedInstanceState != null) {
			lcliente = savedInstanceState.getLong(FpevtcbDBAdapter.CODICLIE);
			lfecha = savedInstanceState.getString(FpevtcbDBAdapter.FECHA);
			
		    //Asignar el cursor (con parametros
		    mCurPcb = mDbHelper.getPevtcb(lcliente, lfecha);
		}
		else { 
			Bundle extras = getIntent().getExtras();
			if (extras != null) {
				lcliente = extras.getLong(FpevtcbDBAdapter.CODICLIE);
				lfecha = extras.getString(FpevtcbDBAdapter.FECHA);
				
			    //Asignar el cursor (con parametros
			    mCurPcb = mDbHelper.getPevtcb(lcliente, lfecha);
			}
			else {
				//System.out.println("Sin parametros");
			    
			    //Asignar el cursor (todos)
			    mCurPcb = mDbHelper.getAllPevtcb();
			    mCurPcb.moveToFirst();
			}
			
		}
	    
	    //Llenar Datos
	    fillData();
	    
		//Ocultar el teclado aqui porque al volver de detalle de pedido, se ejecuta este metodo
	    getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
	  }
    
    @Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		if (mCodipecb != null &&
			mDbHelper.getPevtlnByCB(mCodipecb).getCount() == 0) {
			mDbHelper.deletePevtcb(mCodipecb);
		}
		
    	mCurPcb.close();
    	mDbHelper.close();
    	
		super.onDestroy();
	}
		
/*
Ahora la clase donde la magia ocurre: ListenerTouchViewFlipper. 
Cuando se toca el ViewFlipper (que ocupa toda el rea de la aplicacin) el listener agarra el evento, 
podemos saber qu tipo de evento es con el mtodo getAction(), ACTION_DOWN ocurre cuando el usuario toca la pantalla,
ACTION_MOVE cuando se mueve y ACTION_UP cuando deja de tocarla. El evento tambin nos indica las coordenadas X-Y 
donde el evento ocurri. El movimiento de slidepuede ser perfectamente representado con estos datos, lo que 
haremos ser comparar la coordenada X cuando comienza a tocar la pantalla con la X final, en este caso solo nos 
interesa la coordenada X. Los pasos son los siguientes:

Cuando detectamos ACTION_DOWN registramos la coordenada X.
Cuando detectamos ACTION_UP registramos la coordenada X.
Restamos ambas coordenadas y vemos cuanto -y para adonde- se desplazo el dedo.
En base a ese desplazamiento avanzamos a la siguiente vista, retrocedemos o no hacemos nada.	

Se puede asignar una distancia mnima de movimiento para que no sea tan sensible. En un Motorola Atrix con solo 
tocar la pantalla se cambiaba la ventana.

Notar que al captutar el evento ACTION_DOWN se devuelve true, caso contrario se devuelve false. True significa que 
el evento ha sido consumido. Es importante esto ya que algunos controles tambin escuchan los eventos (como los 
botones).

Para hacerlo ms atractivo incorporaremos animaciones a la transicin de las vistas. Existen animaciones para la 
salida y entrada de vistas. Ahora la Actividad completa con la incorporacin de las animaciones. Al final los mtodos 
que devuelven los objetos Animation:
  
 */
	private class ListenerTouchViewFlipper implements View.OnTouchListener{

		public boolean onTouch(View v, MotionEvent event) {
			
			if (mCurPcb.getCount()>0) {
				
				switch (event.getAction()) {
				
				case MotionEvent.ACTION_DOWN: //Cuando el usuario toca la pantalla por primera vez
					init_x=event.getX();
					return true;

				case MotionEvent.ACTION_UP: //Cuando el usuario deja de presionar
					float distance =init_x-event.getX();

					if (distance > 0) {
	                    vf.setInAnimation(inFromRightAnimation());
                    	vf.setOutAnimation(outToLeftAnimation());
						
	                    if (mCurPcb.isLast() == false){
		                    mCurPcb.moveToNext();
		                    fillData();
		                    vf.showNext();
		                    //vf.getChildAt(vf.getDisplayedChild() + 1); // next
	                    }
	                    else { // caso de que estamos en crear pedido (mCurPcb.getCount = 1) desplazar hacia la derecha = crear linea
	                    	if (mCurPcb.getCount() == 1) {
	                    		InsertLn ();
	                    	}
	                    }
		    		}

		    		if (distance < 0) {
		    			vf.setInAnimation(inFromLeftAnimation());
	                    vf.setOutAnimation(outToRightAnimation());
		    						                    
                    	if (mCurPcb.isFirst() == false){
                    		mCurPcb.moveToPrevious();
                    		fillData();
                    		vf.showPrevious();
                    		//vf.getChildAt(vf.getDisplayedChild() - 1); // previous
	                    	}
			    		}
	
					default:
						break;
					}
					return false;
					
				}
				return false;
			}
	}

	private void fillData() {
        try{
        	
        	Cursor curFinci = null;
        	String Codiinci;
        	String Descinci = "";
        	String Descincitmp = "";
        	
        	mpecb_pdpsText.setText("");
	        mpecb_fechaText.setText("");
	        mpecb_cliText.setText("");
	        mpecb_descText.setText("");
			mpecb_obs1Text.setText("");
			mpecb_obs2Text.setText("");
			mpecb_inciText.setText("");
			mpecb_inciText.setVisibility(View.GONE);
			mpecb_mcliText.setText("");
			mpecb_tmcliText.setText("");
			mGraba = "";
	        
        	//Obtenemos el cursor teniendo en cuenta el posible filtro de bsqueda
			mCodipecb      = mCurPcb.getLong(mCurPcb.getColumnIndexOrThrow(FpevtcbDBAdapter.CODIPECB));
        	Long mCodiclie = mCurPcb.getLong(mCurPcb.getColumnIndexOrThrow(FpevtcbDBAdapter.CODICLIE));
        	
        	mpecb_pdpsText.setText(String.valueOf( mCurPcb.getPosition()+1 ) +" de "+ String.valueOf( mCurPcb.getCount() ));
        	
        	String strDate = mCurPcb.getString(mCurPcb.getColumnIndexOrThrow(FpevtcbDBAdapter.FECHA));
        	dtDate         = (new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")).parse(strDate);	
        	DisplayDate();
        	
	        mpecb_cliText.setText(mCodiclie.toString());
	        
	        //para mensaje de cliente
	        String lcodimcli = mCurPcb.getString(mCurPcb.getColumnIndexOrThrow(FpevtcbDBAdapter.CODIMCLI));
	        String ltextmcli = mCurPcb.getString(mCurPcb.getColumnIndexOrThrow(FpevtcbDBAdapter.TEXTMCLI));
	        if (ltextmcli.equals("")){
	        	mpecb_mcliText.setText(lcodimcli);
	        	mensamod = false;
	        }
	        else {
		        mpecb_tmcliText.setText( ltextmcli );
		        mensamod = true;
	        }
	        mBtAceptar.setVisibility(View.GONE);
	        
	        if (mCodiclie != null) {
	        	//Para llenar cabecera
	        	Cursor cur  = mDbHelper.getCliente(mCodiclie.intValue());
	        	if (cur.getCount() > 0){
	    			mpecb_descText.setText(cur.getString(cur.getColumnIndexOrThrow(ClienteDBAdapter.DESCRIPCION)));
	        	}
	        	cur.close();
	        	cur = mDbHelper.getFcli(mCodiclie.intValue());
	        	if (cur.getCount() > 0){
	    			mpecb_obs1Text.setText(cur.getString(cur.getColumnIndexOrThrow(FcliDBAdapter.OBSERVACION1)));
	    			mpecb_obs2Text.setText(cur.getString(cur.getColumnIndexOrThrow(FcliDBAdapter.OBSERVACION2)));
	    			
    				//consultamos incidencia
	    			Codiinci = "";
	    			Codiinci = cur.getString(cur.getColumnIndexOrThrow(FcliDBAdapter.CODIINCI));
	    			if ( !Codiinci.equalsIgnoreCase("") ) {
	    				curFinci = mDbHelper.getFinci(Codiinci);
	    				if (curFinci.getCount() > 0) {
	    					Descinci = curFinci.getString(curFinci.getColumnIndexOrThrow(FinciDBAdapter.DESCINCI));
	    					mpecb_inciText.setVisibility(View.VISIBLE);
	    					mpecb_inciText.setText( Descinci );
	    					mGraba = curFinci.getString(curFinci.getColumnIndexOrThrow(FinciDBAdapter.GRABA));
	    				}
	    				curFinci.close();
	    			}
	    			//consultamos incidencia temporal
	    			Codiinci = "";
	    			Codiinci = cur.getString(cur.getColumnIndexOrThrow(FcliDBAdapter.CODIINCITMP));
	    			if ( !Codiinci.equalsIgnoreCase("") ) {
	    				curFinci = mDbHelper.getFinci(Codiinci);
	    				if (curFinci.getCount() > 0) {
	    					Descincitmp = curFinci.getString(curFinci.getColumnIndexOrThrow(FinciDBAdapter.DESCINCI));
	    					mpecb_inciText.setVisibility(View.VISIBLE);
	    					mpecb_inciText.setText( Descincitmp );
	    					mGraba = curFinci.getString(curFinci.getColumnIndexOrThrow(FinciDBAdapter.GRABA));
	    				}
	    				curFinci.close();
	    			}
	    			
	    			if (mGraba.equalsIgnoreCase("N")) {
						mpecb_inciText.setBackgroundColor( this.getResources().getColor(R.color.Yellow) );
						mpecb_inciText.setTextColor(this.getResources().getColor(R.color.Black));
					}
					if (mGraba.equalsIgnoreCase("S")) {
						mpecb_inciText.setBackgroundColor( this.getResources().getColor(R.color.LimeGreen) );
						mpecb_inciText.setTextColor(this.getResources().getColor(R.color.Black));
					}
					
					//si tiene incidencia, incidencia temporal y es nuevo pedido.
					if ( (!Descinci.equalsIgnoreCase("")) && (!Descincitmp.equalsIgnoreCase("")) && (lcliente != 0)) {
						
						LayoutInflater inflater = getLayoutInflater();
						View dialoglayout = inflater.inflate(R.layout.dialogo, (ViewGroup) findViewById(R.id.dg_layout_root));
						
						AlertDialog.Builder msgbox = new AlertDialog.Builder(this);

						msgbox.setView(dialoglayout)
								.setIcon(android.R.drawable.ic_dialog_alert)
								.setCancelable(false)
								.setTitle("DOBLE INCIDENCIA")
								
								.setMessage("Cliente con dos incidencias:")
							    .setNeutralButton("Aceptar", null);
						
						TextView text = (TextView) dialoglayout.findViewById(R.id.dg_textView);
						text.setSingleLine(false);
						text.setVisibility(View.VISIBLE);
						text.setText("1.- " + Descincitmp + "\n\n"  +
					    	  	"2.- " + Descinci);
						msgbox.show();

					}
					
	        	}
	        	cur.close();
	        	
	        }
	        
	        //Para las lineas de pedidos
	        fillDataln();

        }
        catch (Exception e){
        		msgBox("Error en el acceso a los datos.", "", true);
        }
    }

	@SuppressWarnings("deprecation")
	private void fillDataln() {
	    
        try{
        	//Obtenemos el cursor teniendo en cuenta el posible filtro de bsqueda
        	Cursor cur = this.mDbHelper.getAllLinArt(mCodipecb);
	
	        String[] from = new String[] { 	FpevtlnDBAdapter.CODIPELN,
	        								FpevtlnDBAdapter.CODIARTI, 
	        							   	ArticuloDBAdapter.DESCARTI,
	        							   	FpevtlnDBAdapter.CANTTOTA,
	        							   	FpevtlnDBAdapter.CODIUNID,
	        							   	FpevtlnDBAdapter.PRECIO}; 
	        int[] to = new int[] { 	R.id.peln_id,
	        						R.id.peln_articulo, 
	        						R.id.peln_descarti,
	        						R.id.peln_cantidad,
	        						R.id.peln_codiunid,
	        						R.id.peln_precio};

	        // Now create a simple cursor adapter and set it to display
	        mPedidoRow.setAdapter(new SimpleCursorAdapter(this, R.layout.pedido_row, cur, from, to) {
	        	

				@Override
	            public void setViewText(TextView v, String text) {
	            	switch (v.getId()) {
	      	      		case R.id.peln_precio:
	      	      			DecimalFormat df = new DecimalFormat("###,##0.00");
	      	      			super.setViewText(v, df.format(Double.valueOf(text)) + "");
	      	      			break;

	      	      		default:
	      	      			super.setViewText(v, text);
	            	}	
	            	
	            }
	        });
	        
        }
        catch (Exception e){
        	msgBox("Error en el acceso a los datos.", "", true);
        }
	}

	        
	
	@Override
	protected Dialog onCreateDialog(int id, Bundle args) {
		switch (id) {
		case DATE_DIALOG_ID:
			Calendar c = Calendar.getInstance();
			c.setTime(dtDate);
			mYear = c.get(Calendar.YEAR);
            mMonth = c.get(Calendar.MONTH);
            mDay = c.get(Calendar.DAY_OF_MONTH);
			
			return new DatePickerDialog(this, mDateSetListener, mYear, mMonth, mDay);
				
		}
		return null;
	}
	
	// the callback received when the user "sets" the date in the dialog
    private DatePickerDialog.OnDateSetListener mDateSetListener = new DatePickerDialog.OnDateSetListener() {

        public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
            mYear = year;
            mMonth = monthOfYear;
            mDay = dayOfMonth;
            
            Calendar ayer = Calendar.getInstance();
            Calendar cal = Calendar.getInstance();
            
            cal.set( year, monthOfYear, dayOfMonth);
            ayer.add(Calendar.DAY_OF_YEAR, -1);
            
            if (cal.getTime().after( ayer.getTime())) {
            	dtDate = cal.getTime();
            	onAceptar(view);
            }
            else {
            	msgBox("Debe cambiar la fecha de servir", "Error", false);
            }
            
        }
        
	};

	//Formatea la fecha y la asigna al TextView
	private void DisplayDate() {
    	String strDate = (new SimpleDateFormat("dd/MM/yyyy")).format(dtDate);
        mpecb_fechaText.setText(strDate);
	}
	
    public void msgBox(String str, String titulo, boolean fin) { 
        AlertDialog.Builder dlgAlert  = new AlertDialog.Builder(this);                       
        dlgAlert.setMessage(str);  
        dlgAlert.setTitle(titulo);
        if (fin) {
	        dlgAlert.setPositiveButton("Aceptar",new DialogInterface.OnClickListener() { 
	            public void onClick(DialogInterface dialog, int whichButton) {
	                finish();
	            } 
	        }); 
        }
        else {
            dlgAlert.setPositiveButton("Aceptar",null); 
        }
        dlgAlert.setCancelable(true); 
        dlgAlert.create().show(); 
    } 

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	getMenuInflater().inflate(R.menu.activity_pedidos, menu);
        if (mGraba.equalsIgnoreCase("N")) {
        	System.out.println( menu.findItem(R.id.INSERTLN_ID).getItemId() );
        	menu.findItem(R.id.INSERTLN_ID).setEnabled(false);
        }
        return true;
    }
	
    @Override
    public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) {
        super.onCreateContextMenu(menu, v, menuInfo);
        menu.add(0, INSERTLN_ID, 0, R.string.pedidos_insertln)
        	.setIcon(android.R.drawable.ic_menu_add);
        menu.add(0, UPDATELN_ID, 0, R.string.pedidos_updateln)
        	.setIcon(android.R.drawable.ic_menu_edit);
        menu.add(0, DELETELN_ID, 0, R.string.pedidos_deleteln)
        	.setIcon(android.R.drawable.ic_menu_delete);
        if (mGraba.equalsIgnoreCase("N")) {
        	menu.findItem(INSERTLN_ID).setEnabled(false);
        }
    }

    @Override
    public boolean onContextItemSelected(MenuItem item) {
    	
    	AdapterContextMenuInfo info = null;
    	
        switch(item.getItemId()) {
        
	        case INSERTLN_ID:
                //System.out.println("Insertar linea");
	        	InsertLn();
	            return true;
	            
	        case UPDATELN_ID:
                info = (AdapterContextMenuInfo) item.getMenuInfo();
                //System.out.println("Modificar linea codigo " + info.id);
                UpdateLn(info.id);
	            return true;
	            
	        case DELETELN_ID:
                info = (AdapterContextMenuInfo) item.getMenuInfo();
                DeleteLn(info.id);
                return true;
	    
        }
        return super.onContextItemSelected(item);
    }
  
	@SuppressWarnings("deprecation")
	@Override
	public boolean onMenuItemSelected(int featureId, MenuItem item) {
		// TODO Auto-generated method stub
    	
        switch(item.getItemId()) {
	        
        	case R.id.VERDET_ID:
        		verDetalle();
        		return true;
        		
        	case R.id.VERRIE_ID:
        		verRiesgo();
        		return true;
        
	        case R.id.MODATE_ID:
	        	showDialog(DATE_DIALOG_ID);
	            return true;
	            
	        case R.id.INSERTLN_ID:
                //System.out.println("Insertar linea");
	        	InsertLn();
	            return true;
	            
	        case R.id.DELETECB_ID:
	        	DeleteCb();
	        	return true;
		    
        }
		return super.onMenuItemSelected(featureId, item);
	}
	
    public void onAceptar(View view) {
        if (UpdateCb()) {
        	int posicion = mCurPcb.getPosition();
        	mCurPcb.requery();
        	mCurPcb.moveToPosition(posicion);
        	DisplayDate();
        	mBtAceptar.setVisibility(View.GONE);
        }
    }
	
    private void verDetalle(){
        Intent intent = new Intent(this, ClienteView.class);
        intent.putExtra(ClienteDBAdapter.CODICLIE, Long.valueOf(mpecb_cliText.getText().toString()) );
        startActivity(intent);
    }
    
    private void verRiesgo(){
        Intent intent = new Intent(this, ClienteRiesgo.class);
        intent.putExtra(ClienteDBAdapter.CODICLIE, Long.valueOf(mpecb_cliText.getText().toString()) );
        startActivity(intent);
    }
    
	private boolean UpdateCb(){
        //Update pevtcb
        String lstDate = (new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")).format(dtDate);
        String lstCodimcli = "";
        String lstTextmcli = "";
        
        if (!mensamod) { //NO se ha modificado el texto de mensaje de cliente
        	lstCodimcli = mpecb_mcliText.getText().toString();
        	lstTextmcli = "";
        }
        else { //SI se ha modificado el texto de mensaje de cliente
        	lstCodimcli = "";
        	lstTextmcli = mpecb_tmcliText.getText().toString();
        }
        
    	return mDbHelper.updatePevtcb(mCodipecb, 
    									lstDate, 
    									Long.valueOf(mpecb_cliText.getText().toString()), 
    									lstCodimcli,
    									lstTextmcli);
	}
	
	private void DeleteCb() {
    	AlertDialog.Builder yesandno = new AlertDialog.Builder(this);   
    	
    	yesandno
    		.setIcon(android.R.drawable.ic_delete)
    		.setTitle("Borrar Pedido")
    		.setMessage("Esta Seguro?")
        	.setPositiveButton("Si", new DialogInterface.OnClickListener() {
        	    @SuppressWarnings("deprecation")
				public void onClick(DialogInterface dialog, int id) {
        	        // User clicked yes
        	    	int posicion = mCurPcb.getPosition();
	                if (mDbHelper.deletePevtcb(mCodipecb)  == true) {

	                	mCurPcb.requery();
	                	if ((posicion+1) > mCurPcb.getCount()) {
	                		mCurPcb.moveToLast();
	                	}
	                	else {
	                		mCurPcb.moveToPosition(posicion);
	                	}
	                	fillData();
	                }

	                
        	    }
        	})
        	.setNegativeButton("No", null)
    		.show();
	}
	
	private void InsertLn () {
		String strDate = (new SimpleDateFormat("yyyy/MM/dd")).format(dtDate);

	    Intent intent = new Intent(this, Pedidoln.class);
	    intent.putExtra(FpevtlnDBAdapter.CODIPECB, mCodipecb);
	    intent.putExtra(FpevtcbDBAdapter.FECHA, strDate);
	    intent.putExtra(FpevtcbDBAdapter.CODICLIE, Long.valueOf(mpecb_cliText.getText().toString()) );
        startActivityForResult(intent, REQUEST_PELN);
	}
	
	private void UpdateLn (long pevtln) {
		//System.out.println("Modificar linea codigo " + pevtln);
		String strDate = (new SimpleDateFormat("yyyy/MM/dd")).format(dtDate);
		
		Intent intent= new Intent(this, Pedidoln.class);
	    intent.putExtra(FpevtlnDBAdapter.CODIPECB, mCodipecb);
	    intent.putExtra(FpevtcbDBAdapter.FECHA, strDate);
	    intent.putExtra(FpevtlnDBAdapter.CODIPELN, pevtln);
	    intent.putExtra(FpevtcbDBAdapter.CODICLIE, Long.valueOf(mpecb_cliText.getText().toString()) );
	    startActivityForResult(intent, REQUEST_PELN);
	}
	
	private void DeleteLn (long pevtln) {
        if (mDbHelper.deletePevtln(pevtln) == true) {
        	//System.out.println("Linea " + info.id + " borrada");
        	fillDataln();
        }
	}
	
    /** Called when the user clicks the buscarMensaje button */
    public void buscarMensaje(View view) {
        Intent intent = new Intent(this, MenListActivity.class);
    	intent.putExtra("TABLA", REQUEST_MENCLI);
    	startActivityForResult(intent, REQUEST_MENCLI);
    }
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub
		super.onActivityResult(requestCode, resultCode, data);
    	
    	try{
	        if (resultCode == RESULT_OK) {
	        	switch(requestCode) {
		        	
		        	case REQUEST_PELN:
		        		fillDataln();
		        		break;
		        		
	    	    	case REQUEST_MENCLI:
			            if (data.hasExtra("MENSAJE")) {
			        		//Lo devuelto en la bsqueda de mensaje, lo metemos en su editText para que el evento
			            	mpecb_mcliText.setText( data.getExtras().getString("MENSAJE") );
			            }
	    	    		break;
		        	}
	        		
	        }
    	}
    	catch (Exception e){
    		msgBox("Error en la bsqueda.", "", true);
    	}
	}

	private Animation inFromRightAnimation() {

    	Animation inFromRight = new TranslateAnimation(
    			Animation.RELATIVE_TO_PARENT,  +1.0f, 
    			Animation.RELATIVE_TO_PARENT,  0.0f,
    			Animation.RELATIVE_TO_PARENT,  0.0f, 
    			Animation.RELATIVE_TO_PARENT,  0.0f );

    	inFromRight.setDuration(250);
    	inFromRight.setInterpolator(new AccelerateInterpolator());

    	return inFromRight;

    }
	
	private Animation outToLeftAnimation() {

		Animation outtoLeft = new TranslateAnimation(

				Animation.RELATIVE_TO_PARENT, 0.0f,
				Animation.RELATIVE_TO_PARENT, -1.0f,
				Animation.RELATIVE_TO_PARENT, 0.0f,
				Animation.RELATIVE_TO_PARENT, 0.0f);

		outtoLeft.setDuration(250);
		outtoLeft.setInterpolator(new AccelerateInterpolator());

		return outtoLeft;

	}
	
	private Animation inFromLeftAnimation() {

		Animation inFromLeft = new TranslateAnimation(

				Animation.RELATIVE_TO_PARENT, -1.0f,
				Animation.RELATIVE_TO_PARENT, 0.0f,
				Animation.RELATIVE_TO_PARENT, 0.0f,
				Animation.RELATIVE_TO_PARENT, 0.0f);

		inFromLeft.setDuration(250);
		inFromLeft.setInterpolator(new AccelerateInterpolator());

		return inFromLeft;

	}
	
	private Animation outToRightAnimation() {

		Animation outtoRight = new TranslateAnimation(

				Animation.RELATIVE_TO_PARENT, 0.0f,
				Animation.RELATIVE_TO_PARENT, +1.0f,
				Animation.RELATIVE_TO_PARENT, 0.0f,
				Animation.RELATIVE_TO_PARENT, 0.0f);

		outtoRight.setDuration(250);
		outtoRight.setInterpolator(new AccelerateInterpolator());

		return outtoRight;

	}
  
}
	  
